<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://gitlab.eclipse.org/eclipse/xfsc/xfsc-spec-2/train/train/" />
      <link rel="shortcut icon" href="../../img/favicon.ico" />
    <title>Trust Management Infrastructure - XFSC-spec-2</title>
    <link rel="stylesheet" href="../../css/theme.css" />
    <link rel="stylesheet" href="../../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Trust Management Infrastructure";
        var mkdocs_page_input_path = "train\\train.md";
        var mkdocs_page_url = "/eclipse/xfsc/xfsc-spec-2/train/train/";
      </script>
    
    <!--[if lt IE 9]>
      <script src="../../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/11.8.0/highlight.min.js"></script>
      <script>hljs.highlightAll();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href="../.." class="icon icon-home"> XFSC-spec-2
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../..">Index</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../notare/notare/">Notarization API Extension</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Trust Management Infrastructure</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#1-introduction">1  Introduction</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#11-document-purpose">1.1 Document Purpose</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#12-product-scope">1.2 Product Scope</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#13-definitions-acronyms-and-abbreviations">1.3  Definitions, Acronyms and Abbreviations</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#14-references">1.4 References</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#15-document-overview">1.5 Document Overview</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#2-product-overview">2 Product Overview</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#21-product-perspective">2.1 Product Perspective</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#22-product-functions">2.2 Product Functions</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#23-product-constraints">2.3 Product Constraints</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#24-user-classes-and-characteristics">2.4 User Classes and Characteristics</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#25-operating-environment">2.5 Operating Environment</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#26-user-documentation">2.6 User Documentation</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#27-assumptions-and-dependencies">2.7 Assumptions and Dependencies</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#3-requirements">3 Requirements</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#31-external-interfaces">3.1 External Interfaces</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#311-user-interfaces">3.1.1 User Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#312-software-interfaces">3.1.2 Software Interfaces</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#313-communications-interfaces">3.1.3 Communications Interfaces</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#32-functional">3.2 Functional</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#33-nonfunctional-requirements">3.3 Nonfunctional Requirements</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#331-http-requirements">3.3.1 HTTP Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#332-logging-requirements">3.3.2 Logging Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#333-performance-requirements">3.3.3 Performance Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#334-safety-requirements">3.3.4 Safety Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#335-security-requirements">3.3.5 Security Requirements</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#336-software-quality-attributes">3.3.6 Software Quality Attributes</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#337-business-rules">3.3.7 Business Rules</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#34-compliance">3.4 Compliance</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#35-design-and-implementation">3.5 Design and Implementation</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#351-installation">3.5.1 Installation</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#352-configuration">3.5.2 Configuration</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#353-distribution">3.5.3 Distribution</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#354-service-meshing">3.5.4 Service Meshing</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#355-standard-technology-stack">3.5.5 Standard Technology Stack</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#356-metrics">3.5.6 Metrics</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#357-configurability">3.5.7 Configurability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#358-maintainability">3.5.8 Maintainability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#359-reusability">3.5.9 Reusability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3510-runtime-stability">3.5.10 Runtime Stability</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3511-high-availability-concepts">3.5.11 High Availability Concepts</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#3512-proof-of-concept">3.5.12 Proof of Concept</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#4-system-features">4 System Features</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#41-trust-framework-and-trust-list-provision">4.1 Trust Framework and Trust List Provision</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#411-description-and-priority">4.1.1 Description and Priority</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#412-stimulusresponse-sequences">4.1.2 Stimulus/Response Sequences</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#413-functional-requirements">4.1.3 Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#42-trusted-content-resolver">4.2 Trusted Content Resolver</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#421-description-and-priority">4.2.1 Description and Priority</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#422-stimulusresponse-sequences">4.2.2 Stimulus/Response Sequences</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#423-functional-requirements">4.2.3 Functional Requirements</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#43-dns-zone-management">4.3 DNS Zone Management</a>
        <ul>
    <li class="toctree-l4"><a class="reference internal" href="#431-description-and-priority">4.3.1 Description and Priority</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#432-stimulusresponse-sequences">4.3.2 Stimulus/Response Sequences</a>
    </li>
    <li class="toctree-l4"><a class="reference internal" href="#433-functional-requirements">4.3.3 Functional Requirements</a>
    </li>
        </ul>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#5-verification">5 Verification</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#51-core-verification-requirements">5.1 Core Verification Requirements</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#52-support-for-kubernetes">5.2 Support for Kubernetes</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#53-functionality-acceptance-criteria">5.3 Functionality Acceptance Criteria</a>
    </li>
        </ul>
    </li>
    </ul>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocme1/ocme1/">Organization Credential Manager Extension</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../ocmwstack/ocmwstack/">Organization Credential Manager W-STACK</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcmcloud/pcmcloud/">Cloud Personal Credential Manager</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../pcme1/pcme1/">Personal Credential Manager Extension 1</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../../tsae1/tsae1/">Trust Services API Extension</a>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../..">XFSC-spec-2</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../.." class="icon icon-home" aria-label="Docs"></a></li>
      <li class="breadcrumb-item active">Trust Management Infrastructure</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h2 id="software-requirements-specification-for-gaia-x-federation-services-trust-management-infrastructure-idmtrain">Software Requirements Specification  for  Gaia-X Federation Services Trust Management Infrastructure IDM.TRAIN</h2>
<p>Published by</p>
<p>eco -- Association of the Internet Industry (eco -- Verband der Internetwirtschaft e.V.) Lichtstrasse 43h 50825 Cologne, Germany</p>
<p>Copyright </p>
<p>© 2023 eco -- Association of the Internet Industry
This work is licensed under the Creative Commons attribution 4.0nInternational License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by/4.0/">http://creativecommons.org/licenses/by/4.0/</a> or send a letter to Creative Commons, PO Box 1866, Mountain View, CA 94042, USA</p>
<p><img alt="" src="../media/image1.png" /></p>
<h4 id="1-introduction">1  <a href="#introduction">Introduction </a></h4>
<blockquote>
<h5 id="11-document-purpose">1.1 <a href="#document-purpose">Document Purpose </a></h5>
<h5 id="12-product-scope">1.2 <a href="#product-scope">Product Scope </a></h5>
<h5 id="13-definitions-acronyms-and-abbreviations">1.3 <a href="#definitions-acronyms-and-abbreviations"> Definitions, Acronyms and Abbreviations</a></h5>
<h5 id="14-references">1.4 <a href="#references">References </a></h5>
<h5 id="15-document-overview">1.5 <a href="#document-overview">Document Overview </a></h5>
</blockquote>
<h4 id="2-product-overview">2 <a href="#product-overview">Product Overview </a></h4>
<blockquote>
<h5 id="21-product-perspective">2.1 <a href="#product-perspective">Product Perspective</a></h5>
<h5 id="22-product-functions">2.2 <a href="#product-functions">Product Functions </a></h5>
<h5 id="23-product-constraints">2.3 <a href="#product-constraints">Product Constraints</a></h5>
<h5 id="24-user-classes-and-characteristics">2.4 <a href="#user-classes-and-characteristics">User Classes and Characteristics</a></h5>
<h5 id="25-operating-environment">2.5 <a href="#operating-environment">Operating Environment</a></h5>
<h5 id="26-user-documentation">2.6 <a href="#user-documentation">User Documentation </a></h5>
<h5 id="27-assumptions-and-dependencies">2.7 <a href="#assumptions-and-dependencies">Assumptions and Dependencies</a></h5>
</blockquote>
<h4 id="3-requirements">3 <a href="#requirements">Requirements </a></h4>
<blockquote>
<h5 id="31-external-interfaces">3.1 <a href="#external-interfaces">External Interfaces</a></h5>
<blockquote>
<h6 id="311-user-interfaces">3.1.1 <a href="#user-interfaces">User Interfaces </a></h6>
<h6 id="312-software-interfaces">3.1.2 <a href="#software-interfaces">Software Interfaces</a></h6>
<h6 id="313-communications-interfaces">3.1.3 <a href="#communications-interfaces">Communications Interfaces</a></h6>
</blockquote>
<h5 id="32-functional">3.2 <a href="#functional">Functional </a></h5>
<h5 id="33-nonfunctional-requirements">3.3 <a href="#nonfunctional-requirements">Nonfunctional Requirements</a></h5>
<blockquote>
<h6 id="331-http-requirements">3.3.1 <a href="#http-requirements">HTTP Requirements </a></h6>
<h6 id="332-logging-requirements">3.3.2 <a href="#logging-requirements">Logging Requirements</a></h6>
<h6 id="333-performance-requirements">3.3.3 <a href="#performance-requirements">Performance Requirements</a></h6>
<h6 id="334-safety-requirements">3.3.4 <a href="#safety-requirements">Safety Requirements</a></h6>
<h6 id="335-security-requirements">3.3.5 <a href="#security-requirements">Security Requirements</a></h6>
<h6 id="336-software-quality-attributes">3.3.6 <a href="#software-quality-attributes">Software Quality Attributes</a></h6>
<h6 id="337-business-rules">3.3.7 <a href="#business-rules">Business Rules </a></h6>
</blockquote>
<h5 id="34-compliance">3.4 <a href="#compliance">Compliance </a></h5>
<h5 id="35-design-and-implementation">3.5 <a href="#design-and-implementation">Design and Implementation</a></h5>
<blockquote>
<h6 id="351-installation">3.5.1 <a href="#installation">Installation </a></h6>
<h6 id="352-configuration">3.5.2 <a href="#configuration">Configuration </a></h6>
<h6 id="353-distribution">3.5.3 <a href="#distribution">Distribution </a></h6>
<h6 id="354-service-meshing">3.5.4 <a href="#service-meshing">Service Meshing </a></h6>
<h6 id="355-standard-technology-stack">3.5.5 <a href="#standard-technology-stack">Standard Technology Stack</a></h6>
<h6 id="356-metrics">3.5.6 <a href="#metrics">Metrics </a></h6>
<h6 id="357-configurability">3.5.7 <a href="#configurability">Configurability </a></h6>
<h6 id="358-maintainability">3.5.8 <a href="#maintainability">Maintainability </a></h6>
<h6 id="359-reusability">3.5.9 <a href="#reusability">Reusability </a></h6>
<h6 id="3510-runtime-stability">3.5.10 <a href="#runtime-stability">Runtime Stability </a></h6>
<h6 id="3511-high-availability-concepts">3.5.11 <a href="#high-availability-concepts">High Availability Concepts</a></h6>
<h6 id="3512-proof-of-concept">3.5.12 <a href="#proof-of-concept">Proof of Concept </a></h6>
</blockquote>
</blockquote>
<h4 id="4-system-features">4 <a href="#system-features">System Features </a></h4>
<blockquote>
<h5 id="41-trust-framework-and-trust-list-provision">4.1 <a href="#trust-framework-and-trust-list-provision">Trust Framework and Trust List Provision</a></h5>
<blockquote>
<h6 id="411-description-and-priority">4.1.1 <a href="#description-and-priority-trust-framework-and-trust-list-provision">Description and Priority</a></h6>
<h6 id="412-stimulusresponse-sequences">4.1.2 <a href="#stimulusresponse-sequences-trust-framework-and-trust-list-provision">Stimulus/Response Sequences</a></h6>
<h6 id="413-functional-requirements">4.1.3 <a href="#functional-requirements-trust-framework-and-trust-list-provision">Functional Requirements</a></h6>
</blockquote>
<h5 id="42-trusted-content-resolver">4.2 <a href="#trusted-content-resolver">Trusted Content Resolver</a></h5>
<blockquote>
<h6 id="421-description-and-priority">4.2.1 <a href="#description-and-priority-trusted-content-resolver">Description and Priority</a></h6>
<h6 id="422-stimulusresponse-sequences">4.2.2 <a href="#stimulusresponse-sequences-trusted-content-resolver">Stimulus/Response Sequences</a></h6>
<h6 id="423-functional-requirements">4.2.3 <a href="#functional-requirements-trusted-content-resolver">Functional Requirements</a></h6>
</blockquote>
<h5 id="43-dns-zone-management">4.3<a href="#dns-zone-management"> DNS Zone Management</a></h5>
<blockquote>
<h6 id="431-description-and-priority">4.3.1 <a href="#description-and-priority-dns-zone-management">Description and Priority</a></h6>
<h6 id="432-stimulusresponse-sequences">4.3.2 <a href="#stimulusresponse-sequences-dns-zone-management">Stimulus/Response Sequences</a></h6>
<h6 id="433-functional-requirements">4.3.3 <a href="#functional-requirements-dns-zone-management">Functional Requirements</a></h6>
</blockquote>
</blockquote>
<h4 id="5-verification">5 <a href="#verification">Verification </a></h4>
<blockquote>
<h5 id="51-core-verification-requirements">5.1 <a href="#core-verification-requirements">Core Verification Requirements</a></h5>
<h5 id="52-support-for-kubernetes">5.2 <a href="#support-for-kubernetes">Support for Kubernetes</a></h5>
<h5 id="53-functionality-acceptance-criteria">5.3 <a href="#functionality-acceptance-criteria">Functionality Acceptance Criteria</a></h5>
</blockquote>
<p>Annex A: TRAIN Overview </p>
<p>Annex B: Overview GXFS Work Packages</p>
<p><strong>List of Figures</strong></p>
<blockquote>
<p>Figure 1 TRAIN: Overview</p>
<p>Figure 2 Trust Framework and Trust List: Stimulus/Response Sequences</p>
<p>Figure 3 Trusted Content Resolver: Stimulus/Response Sequences</p>
<p>Figure 4 DNS Zone Management: Stimulus/Response Sequences</p>
</blockquote>
<p><strong>List of Tables</strong></p>
<blockquote>
<p>Table 1 User Classes and Characteristics</p>
<p>Table 2 Standard Technology Stack </p>
</blockquote>
<h1 id="introduction">Introduction</h1>
<blockquote>
<p>To get general information regarding Gaia-X and the Gaia-X Federation Services please refer to [TAD], [TF] and [PRD].</p>
</blockquote>
<h2 id="document-purpose">Document Purpose</h2>
<blockquote>
<p>The purpose of the document is to specify the requirements of the Identity Management and Trust Subcomponent "Trust Management Infrastructure for Gaia-X (TRAIN)" with the intention of a European wide public tender for implementing this software. The main audience for this document is attendees of the public tender, which are able to supply an open-source software solution for the area of identity and document verification with the purpose to provide digital support for existing certification bodies within Gaia-X.</p>
</blockquote>
<h2 id="product-scope">Product Scope</h2>
<blockquote>
<p>The purpose of this product is to provide components for establishing and verifying the root of trust for participants in the distributed Gaia-X ecosystem and credentials issued by these entities. This is achieved through the introduction of trust lists combined with anchoring of pointers in the DNS. The conceptual framework for this is described in [GX.TRUST].</p>
<p>Gaia-X Federations and other entities are supported in the sovereign publication and administration of trust lists for their specific trust frameworks. Verifying entities are supported in their sovereign trust decisions. To achieve this, the following functionalities MUST be developed:</p>
</blockquote>
<ul>
<li>
<p>Trust Framework Configuration</p>
</li>
<li>
<p>Trust List Management</p>
</li>
<li>
<p>Zone Manager Handler</p>
</li>
<li>
<p>Trusted Content Resolver (Extended Universal Resolver) + Libraries</p>
</li>
<li>
<p>DNS Zone Manager</p>
</li>
</ul>
<blockquote>
<p>Please note that the libraries are intentional for different languages such as GO, Java, Python and Javascript. It's also intentional to create the libraries as helpers for using the extended universal resolver, by adding content resolver steps, validation routines for VC and other assistive functionalities.</p>
<p><img alt="" src="../media/image2.png" /></p>
<p>If it's required to do code restructurings, modifying existing
solutions by adding new microservices etc. (e.g., the universal
resolver) then this is explicitly required.</p>
<p>Please note, that it is explicitly required to deliver the software up and running. Responsibility for existing code cannot be shifted to previous development teams.</p>
</blockquote>
<hr />
<h2 id="definitions-acronyms-and-abbreviations">Definitions, Acronyms and Abbreviations</h2>
<blockquote>
<p>The IDM and Trust Architecture Overview Document [[IDM.AO]]{.underline} MUST be considered and applied as the core technical concept that includes also the Terminology and Glossary.</p>
</blockquote>
<h2 id="references">References</h2>
<table>
<thead>
<tr>
<th>Name</th>
<th>Reference</th>
<th>Link</th>
</tr>
</thead>
<tbody>
<tr>
<td>[IDM.AO]</td>
<td>Gaia-X WP1[1] (2021), Architecture Overview - Please refer to annex "GX_IDM_AO"</td>
<td></td>
</tr>
<tr>
<td>[GX.TRUST]</td>
<td>Trust Management Infrastructure for Gaia-X, Concept Document - Please refer to annex "Trust Management Infrastructure for GX"</td>
<td></td>
</tr>
<tr>
<td>[LIGHTEST.TSPA]</td>
<td>LIGHTest TSPA Source Code - <a href="https://github.com/H2020LIGHTest/TrustSchemePublicationAuthority">GitHub Link</a></td>
<td></td>
</tr>
<tr>
<td>[LIGHTEST.ZM]</td>
<td>LIGHTest Zone Manager Source Code - <a href="https://github.com/H2020LIGHTest/ZoneManager">GitHub Link</a></td>
<td></td>
</tr>
<tr>
<td>[PRD]</td>
<td>Gaia-X Policy Rules and Labelling Document (2022) - <a href="https://docs.gaia-x.eu/policy-rules-committee/trust-framework/latest/">Link</a></td>
<td></td>
</tr>
<tr>
<td>[RFC2119]</td>
<td>Network Working Group (1997) Key words for use in RFCs to Indicate Requirement Levels - <a href="https://tools.ietf.org/html/rfc2119">RFC Link</a></td>
<td></td>
</tr>
<tr>
<td>[TAD]</td>
<td>Gaia-X Architecture Document (2022) - <a href="https://docs.gaia-x.eu/technical-committee/architecture-document/latest/">Link</a></td>
<td></td>
</tr>
<tr>
<td>[TDR]</td>
<td>Gaia-X Federation Services Technical Development Requirements - Please refer to annex "GXFS_Technical_Development_Requirements"</td>
<td></td>
</tr>
<tr>
<td>[TF]</td>
<td>Gaia-X Trust Framework (2022) - <a href="https://docs.gaia-x.eu/policy-rules-committee/trust-framework/latest/">Link</a></td>
<td></td>
</tr>
<tr>
<td>[TRAIN]</td>
<td>TRAIN (Trust Management Infrastructure) - Website - <a href="https://train.trust-scheme.de/info/">Link</a></td>
<td></td>
</tr>
<tr>
<td>[TRAIN.ESSIF]</td>
<td>ESSIF Gitlab for TRAIN with Sourcecode - <a href="https://gitlab.grnet.gr/essif-lab/infrastructure/fraunhofer">GitLab Link</a></td>
<td></td>
</tr>
<tr>
<td>[VC.DataModel]</td>
<td>W3C (2022), Verifiable Credentials Data Model v1.1 - <a href="https://www.w3.org/TR/vc-data-model">W3C Link</a></td>
<td></td>
</tr>
</tbody>
</table>
<blockquote>
<p>[1] Please refer to appendix B for an overview and explanation of the Work Packages (WP).</p>
</blockquote>
<h2 id="document-overview">Document Overview</h2>
<blockquote>
<p>The document describes the product perspective, functions, and constraints. It furthermore lists the functional and non-functional requirements and defines the system features in detail. The listed requirements are binding. Requirements as an expression of normative specifications are identified by a unique ID in square brackets (e.g. <strong>[IDM.ID.EX.Number]</strong>) and the keywords MUST, MUST NOT, SHOULD, SHOULD NOT, MAY, corresponding to RFC 2119 [<a href="https://tools.ietf.org/html/rfc2119">[RFC 2119]</a>], are written in capital letters (see also [IDM.AO] - Methodology).</p>
</blockquote>
<h1 id="product-overview">Product Overview</h1>
<h2 id="product-perspective">Product Perspective</h2>
<blockquote>
<p>TRAIN provides a trust management infrastructure for Gaia-X Federation Services (GXFS). The TSA can use the Trusted Component Resolver Libraries to verify the institutional trust of verifiable credentials. The Organizational Credential Manager (OCM) can use the Trusted Component Resolver Libraries to validate the trust of the organizational verifiable credentials before storing them in the wallet. The Notary (via the Notarization API) uses the TSPA Connector to enroll trusted entities into the trust framework and add them via the TSPA/Federator to the Trust List.</p>
</blockquote>
<p><img alt="" src="../media/image3.png" /></p>
<blockquote>
<p>Figure 1 TRAIN: Overview</p>
<p>A bigger overview of Figure 1 can be found at the end of this document in annex A.</p>
</blockquote>
<h2 id="product-functions">Product Functions</h2>
<blockquote>
<p>The core functions of IDM.TRAIN are:</p>
</blockquote>
<ul>
<li>
<p>Provision of a Trust Framework and Trust lists (TSPA Manager is responsible for this functionality):</p>
<ul>
<li>
<p>Allows for configuration of a Trust Framework</p>
</li>
<li>
<p>Allows for Trust List Management</p>
</li>
<li>
<p>Provides federation/organization/participant specific Trust Lists in different formats</p>
</li>
</ul>
</li>
<li>
<p>Anchoring a Trust Framework and Trust List into the DNS (Zone
    Manager is responsible for this functionality):</p>
<ul>
<li>
<p>Allows for global discovery based on an established and trusted infrastructure</p>
</li>
<li>
<p>Trust Frameworks are anchored in DNS Pointer Resource Record (PTR RR)</p>
</li>
<li>
<p>Trust List URI DID is anchored in DNS URI Resource Record (URI RR)</p>
</li>
<li>
<p>DNSSEC allows for chain of trust</p>
</li>
</ul>
</li>
<li>
<p>Enrollment of trusted entities into the Trust Framework (TSPA
    connector is responsible for this functionality):</p>
<ul>
<li>Notary (via the Notarization API) uses the TSPA connector to enroll trusted entities to the Trust Lists</li>
</ul>
</li>
<li>
<p>Verifying the Institutional Trust of Verifiable Credentials:</p>
<ul>
<li>
<p>Trusted Content Resolver is responsible for this functionality</p>
</li>
<li>
<p>Allows Global Discovery of Trust Frameworks through DNS Resolver</p>
</li>
<li>
<p>The content from terms of Use of the verifiable credential will be used for trust discovery</p>
</li>
<li>
<p>Verification of issuer details of the credential with the information of the trust list</p>
</li>
<li>
<p>Integrity of VC must also be verified</p>
</li>
<li>
<p>Integrity of the chain of trust of DNSSEC must be validated.</p>
</li>
</ul>
</li>
</ul>
<h2 id="product-constraints">Product Constraints</h2>
<h4 id="idmtrain00000-the-document-idmao-is-the-common-basis-for-this-functional-specification">[IDM.TRAIN.00000] The document IDM.AO is the common basis for this functional specification</h4>
<blockquote>
<p>The architecture document [IDM.AO] is an essential part of this specification and a prerequisite for understanding the context. The specifications and requirements from the Architecture Document [TAD] MUST be taken into account during implementation.</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>Please note, that part of the functional requirements require Business Analysts to analyze the requirements of Trust Frameworks and different Trust List formats. Inputs from Business Analysts will be required for the development team set up.</p>
</blockquote>
<hr />
<h4 id="idmtrain00001-the-document-gxtrust-is-the-basis-for-the-train-trust-concept">[IDM.TRAIN.00001] The document GX.TRUST is the basis for the TRAIN Trust concept</h4>
<blockquote>
<p>The Trust Management Infrastructure for Gaia-X document [GX.TRUST] is an essential part of this specification and a prerequisite for understanding the concept for the Gaia-X Trust Infrastructure. It MUST be taken into account during implementation.  </p>
</blockquote>
<h4 id="idmtrain00002-implementation-requirement-for-tspa-and-zone-manager">[IDM.TRAIN.00002] Implementation Requirement for TSPA and Zone Manager</h4>
<blockquote>
<p>The Code Base of TSPA [LIGHTEST.TSPA] and Zone Manager [LIGHTEST.ZM] MUST be taken as reference and MUST be extended based on the functionalities. For example: Trust Framework Initialization and enrollment in DNS follows the format of <strong>_scheme._trust.federation.company1.de</strong> for both PTR and URI records. </p>
</blockquote>
<h2 id="user-classes-and-characteristics">User Classes and Characteristics</h2>
<table>
<thead>
<tr>
<th><strong>User Class</strong></th>
<th><strong>Description</strong></th>
<th><strong>Frequency</strong></th>
<th><strong>Expertise</strong></th>
<th><strong>Privilege Level</strong></th>
<th><strong>Product Usage</strong></th>
</tr>
</thead>
<tbody>
<tr>
<td><em>Administrator</em></td>
<td>Sets up Zone Manager, Trust Framework Configuration, Trust List Initialization</td>
<td>Low</td>
<td>High</td>
<td>High</td>
<td>Maintenance</td>
</tr>
<tr>
<td><em>Notary</em></td>
<td>Uses TSPA Connector to manage the Trust List</td>
<td>High</td>
<td>High</td>
<td>High</td>
<td>Administration of enrollment of trusted entities to the Trust List</td>
</tr>
<tr>
<td><em>TSA / Developers</em></td>
<td>Uses Trusted Content Resolver to verify the institutional trust of the verifier and verify the trust of the issuer details in the Trust Framework</td>
<td>High</td>
<td>High</td>
<td>Low</td>
<td>Verification of inclusion of issuer details in the Trust Framework</td>
</tr>
<tr>
<td><em>PCM</em></td>
<td>Uses the trust list to verify the trust of the issuer/verifier</td>
<td>High</td>
<td>High</td>
<td>Low</td>
<td>Verification or connection establishment</td>
</tr>
<tr>
<td><em>AAS</em></td>
<td>Uses the trust list to decide if a public key must be part of the domain</td>
<td>High</td>
<td>High</td>
<td>Low</td>
<td>Cyclic/During Startup</td>
</tr>
<tr>
<td><em>OCM(s)</em></td>
<td>Uses the trust lists to decide if a connection is trustworthy</td>
<td>High</td>
<td>High</td>
<td>Low</td>
<td>On Connection establishment</td>
</tr>
</tbody>
</table>
<blockquote>
<p>Table 1 User Classes and Characteristics</p>
</blockquote>
<h2 id="operating-environment">Operating Environment</h2>
<h4 id="idmtrain00003-kubernetes-environment">[IDM.TRAIN.00003] Kubernetes Environment</h4>
<blockquote>
<p>The product MUST be operable on standard Kubernetes based environments without any hardware restrictions. The reference environment for demonstration and development purposes MUST be on a SCS cluster (Sovereign Cloud Stack) provided by the contractor. In addition, the developed components must also run in a restricted developer local environment.  </p>
</blockquote>
<h2 id="user-documentation">User Documentation</h2>
<h4 id="idmtrain00004-administration-documentation">[IDM.TRAIN.00004] Administration Documentation</h4>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Installation Manuals for Zone Manager, TSPA Manager</p>
</li>
<li>
<p>Trust Framework Configuration and Trust List Management</p>
</li>
<li>
<p>Description of Deployment/Compile Process</p>
</li>
<li>
<p>Description of the Automatic Tests / Verification</p>
</li>
<li>
<p>How to build the products from source code  </p>
</li>
</ul>
<h4 id="idmtrain00005-user-documentation">[IDM.TRAIN.00005] User Documentation</h4>
<blockquote>
<p>The documentation MUST contain:</p>
</blockquote>
<ul>
<li>
<p>Short Software Description (why and for what, when to use, how use, where to use)</p>
</li>
<li>
<p>Usage guide (Trusted Content Resolver)</p>
</li>
<li>
<p>Usage guide for installation of libraries with GO, Javascript, Java and Python</p>
</li>
<li>
<p>Usage guide to integrate with Notarization Service (NOT)</p>
</li>
<li>
<p>Usage and integration guide for TSA, OCM, PCM</p>
</li>
<li>
<p>GDPR design decisions</p>
</li>
<li>
<p>Security concept</p>
</li>
<li>
<p>Operations concept for all components</p>
</li>
<li>
<p>Blueprint guides how to setup a federation in usage of all components (step by step)</p>
</li>
<li>
<p>FAQ</p>
</li>
<li>
<p>Keyword Directory  </p>
</li>
</ul>
<h2 id="assumptions-and-dependencies">Assumptions and Dependencies</h2>
<blockquote>
<p>An understanding of the overall Gaia-X architecture and philosophy and the Trust Management Infrastructure Concept is necessary. Please refer to [IDM.AO] and [GX.TRUST].</p>
<p>The control over minimum of 2 fully qualified domains or subdomains is strictly required for the product in combination with an authoritative DNSSec Server.</p>
</blockquote>
<h1 id="requirements">Requirements</h1>
<h2 id="external-interfaces">External Interfaces</h2>
<h3 id="user-interfaces">User Interfaces</h3>
<h4 id="idmtrain00006-trust-framework-configuration">[IDM.TRAIN.00006] Trust Framework Configuration</h4>
<blockquote>
<p>The product MUST provide a Web UI which allows the administrator to add new trust frameworks and corresponding DIDs.  </p>
</blockquote>
<h4 id="idmtrain00007-trust-zone-visualization">[IDM.TRAIN.00007] Trust Zone Visualization</h4>
<blockquote>
<p>The product MUST provide a Web UI which visualizes the content of a trustzone (e.g., zones, pointers, DIDs etc.) for external/public users.  </p>
</blockquote>
<h3 id="software-interfaces">Software Interfaces</h3>
<h4 id="idmtrain00008-universal-did-resolver2-idmtrain00008-universal-did-resolver2-unnumbered">[IDM.TRAIN.00008] Universal DID Resolver[2] {#idm.train.00008-universal-did-resolver2 .unnumbered}</h4>
<blockquote>
<p>The DIF Universal Resolver is the product basis that is used for resolving trusted content of DIDs. For building the trusted content resolver, this software is the basis that is to be enhanced.  </p>
</blockquote>
<h6 id="2-httpsgithubcomdecentralized-identityuniversal-resolver">[2] <a href="https://github.com/decentralized-identity/universal-resolver"><u>[https://github.com/decentralized-identity/universal-resolver]</u></a></h6>
<h4 id="idmtrain00009-dns-resolver">[IDM.TRAIN.00009] DNS Resolver</h4>
<blockquote>
<p>An Open-Source DNS Resolver MUST be used to discover PTR, URI, DNSSEC Resource Records (RR). And this MUST be integrated with Trusted Content Resolver.  </p>
</blockquote>
<h4 id="idmtrain00010-authoritative-dnssec-name-servers">[IDM.TRAIN.00010] Authoritative DNSSec Name Servers</h4>
<blockquote>
<p>DNS Name Servers such as NSD[3] and KNOT DNS[4] MUST be used and tested for DNS Zone installation and configuration.<br />
</p>
</blockquote>
<h6 id="3-httpswwwnlnetlabsnlprojectsnsdabout">[3] <a href="https://www.nlnetlabs.nl/projects/nsd/about/"><u>[https://www.nlnetlabs.nl/projects/nsd/about/]</u></a></h6>
<h6 id="4-httpswwwknot-dnscz">[4] <a href="https://www.knot-dns.cz/"><u>[https://www.knot-dns.cz/]</u></a></h6>
<h4 id="idmtrain00011-cryptographic-libraries">[IDM.TRAIN.00011] Cryptographic Libraries</h4>
<blockquote>
<p>Open-Source Cryptographic libraries compliant with the BSI[5] and EU DSS[6] rules including BSI TR- 02102-1[7] MUST be used for VC/trustlist signing, VC / trustlist proof validation and DNSSEC Trust Chain Validation.  </p>
</blockquote>
<h6 id="5-httpswwwbsibunddeenthemenunternehmen-und-organisationenstandards-und-zertifizierungkryptografische-vorgabenkryptografische-vorgaben_nodehtml">[5] <a href="https://www.bsi.bund.de/EN/Themen/Unternehmen-und-Organisationen/Standards-und-Zertifizierung/Kryptografische-Vorgaben/kryptografische-vorgaben_node.html"><u>[https://www.bsi.bund.de/EN/Themen/Unternehmen-und-Organisationen/Standards-und-Zertifizierung/Kryptografische-Vorgaben/kryptografische-vorgaben_node.html]</u></a></h6>
<h6 id="6-httpseceuropaeudigital-building-blockswikisdisplaydigitaldigitalsignatureservice-dss">[6] <a href="https://ec.europa.eu/digital-building-blocks/wikis/display/DIGITAL/Digital+Signature+Service+-++DSS"><u>[https://ec.europa.eu/digital-building-blocks/wikis/display/DIGITAL/Digital+Signature+Service+-++DSS]</u></a></h6>
<h6 id="7-httpswwwbsibunddeshareddocsdownloadsdebsipublikationentechnischerichtlinientr02102bsi-tr-02102html">[7] <a href="https://www.bsi.bund.de/SharedDocs/Downloads/DE/BSI/Publikationen/TechnischeRichtlinien/TR02102/BSI-TR-02102.html"><u>[https://www.bsi.bund.de/SharedDocs/Downloads/DE/BSI/Publikationen/TechnischeRichtlinien/TR02102/BSI-TR-02102.html]</u></a></h6>
<h3 id="communications-interfaces">Communications Interfaces</h3>
<h4 id="idmtrain00012-eventing-idmtrain00012-eventing-unnumbered">[IDM.TRAIN.00012] Eventing {#idm.train.00012-eventing .unnumbered}</h4>
<blockquote>
<p>If the use of events within the software architecture is required, it is mandatory to use software abstraction according to CloudEvents specification[8] for publishing and subscription. The minimal supported protocol binding MUST be HTTP[9] and JSON[10] Protocol Binding.  </p>
</blockquote>
<h6 id="8-httpscloudeventsio">[8] <a href="https://cloudevents.io/"><u>[https://cloudevents.io/]</u></a></h6>
<h6 id="9-httpsgithubcomcloudeventsspecblobv102cloudeventsbindingshttp-protocol-bindingmd">[9] <a href="https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md"><u>[https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/bindings/http-protocol-binding.md]</u></a></h6>
<h6 id="10-httpsgithubcomcloudeventsspecblobv102cloudeventsformatsjson-formatmd">[10] <a href="https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/formats/json-format.md"><u>[https://github.com/cloudevents/spec/blob/v1.0.2/cloudevents/formats/json-format.md]</u></a></h6>
<h4 id="idmtrain00013-eventing-infrastructure">[IDM.TRAIN.00013] Eventing Infrastructure</h4>
<blockquote>
<p>The event broker for the eventing MUST abstract the storage and delivery infrastructure. In Kubernetes environments, the broker MUST be uniform across all Lots. (e.g., KNative[11])</p>
</blockquote>
<h6 id="11-httpsknativedevdocs">[11] <a href="https://knative.dev/docs/"><u>[https://knative.dev/docs/]</u></a></h6>
<h2 id="functional">Functional</h2>
<h4 id="idmtrain00014-trust-framework-configuration">[IDM.TRAIN.00014] Trust Framework Configuration</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality MUST allow the creation of trust frameworks, the creation and configuration of DIDs with well-known did configurations[12], instantiation of trust lists, the envelopment of trust lists in Verifiable Credentials with proof and configuring the enveloped VCs in the service end point of DID Documents. The Sequence Diagram (Figure 2, System Features Section) elaborates the process. Each and every process MUST have separate API endpoints to instantiation.</p>
</blockquote>
<h6 id="12-httpsidentityfoundationwell-knownresourcesdid-configuration">[12] <a href="https://identity.foundation/.well-known/resources/did-configuration/"><u>[https://identity.foundation/.well-known/resources/did-configuration/]</u></a></h6>
<blockquote>
<p><em>Constraints</em></p>
<p>The following constraints MUST be fulfilled:</p>
</blockquote>
<ul>
<li>
<p>Allow creation and mapping of multiple trust frameworks (multiple federations/domains)</p>
</li>
<li>
<p>Allow referencing of trust frameworks from other domains</p>
</li>
<li>
<p>Configure DID as URI record with corresponding trust frameworks</p>
</li>
<li>
<p>Verify the DID with well-known DID configuration before enrolling in URI record</p>
</li>
<li>
<p>Creation of digital signed Trust List with different formats - json and xml</p>
</li>
<li>
<p>Allow creation of VC with trust list end point as credential subject</p>
</li>
<li>
<p>Allow signature of VC- and storage of VC Trust Lists</p>
</li>
<li>
<p>Each process MUST have separate API endpoints</p>
</li>
</ul>
<blockquote>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Zone Manager</p>
</li>
<li>
<p>Trust List Storage</p>
</li>
<li>
<p>VC Storage</p>
</li>
<li>
<p>Zone Data Storage</p>
</li>
<li>
<p>Zone Manager Connector</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ol>
<li>
<p>Trust Framework enrollment</p>
</li>
<li>
<p>DID enrollment</p>
</li>
<li>
<p>Envelope Trust List Endpoint</p>
</li>
<li>
<p>Instantiating Trust List (Storage at Web Server or IPFS)</p>
</li>
</ol>
<blockquote>
<p><em>Output</em></p>
</blockquote>
<ol>
<li>
<p>Creation of Trust Framework as PTR record in DNS</p>
</li>
<li>
<p>DID enrolled as URI RR mapped with corresponding Trust Framework</p>
</li>
<li>
<p>Verifiable Credential with Trust List endpoint as Credential Subject</p>
</li>
<li>
<p>Trust List published in storage with retrievable API endpoint</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>A request update of trust frameworks and DID configuration is
    successfully reflected in the DNS Zone File (200)</p>
</li>
<li>
<p>An instantiation of a trust list is reflected in the trust list storage with possibility to retrieve via API endpoints</p>
</li>
<li>
<p>Creation of a VC is allowed with ability to sign the credential</p>
</li>
<li>
<p>A wrong context or missing data leads to an exception (400)</p>
</li>
<li>
<p>An audit entry is created</p>
</li>
<li>
<p>An error is provided if a record is in progress by the operator</p>
</li>
<li>
<p>Should be able to reference Trust Frameworks from other Domains  </p>
</li>
</ol>
<h4 id="idmtrain00015-trust-list-management">[IDM.TRAIN.00015] Trust List Management</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality MUST allow CRUD (create, read, update, delete) operations on the trust list at the Trusted Data Store. It must also allow for identifying different types of requests based on the enrollment inputs, for example: federation, organization, participant, service provider. If the organization or federation enrolls with its own trust framework, the trust framework name MUST be enrolled in the DNS as PTR record using the Zone Manager Handler.</p>
<p><em>Constraints</em></p>
<p>The following constraints MUST be fulfilled:</p>
</blockquote>
<ul>
<li>
<p>Support JSON and XML trust-list update</p>
</li>
<li>
<p>Have separate endpoints for create, read, update, delete functionalities</p>
</li>
<li>
<p>Support multiple forms of storage on IPFS and HTTPS WebServer</p>
</li>
<li>
<p>Identify and enroll the trust framework into DNS Zone file as PTR RR</p>
</li>
</ul>
<blockquote>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Database of Trusted Content Storage</p>
</li>
<li>
<p>Zone Manager Handler</p>
</li>
<li>
<p>Zone Manager</p>
</li>
<li>
<p>Notarization API</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
<p>A confirmed request record. This MUST include:</p>
</blockquote>
<ol>
<li>
<p>DID of the organization</p>
</li>
<li>
<p>URI of the trust list</p>
</li>
<li>
<p>URI of the schema</p>
</li>
<li>
<p>Metadata of the entity (to be specified further according to
    business analyst analysis)</p>
<ul>
<li>
<p>Legal Name</p>
</li>
<li>
<p>Certification details</p>
</li>
<li>
<p>Assurance Levels</p>
</li>
</ul>
</li>
<li>
<p>Configure supported DID methods</p>
</li>
<li>
<p>Type of other digital credentials supported (example: x509)</p>
</li>
<li>
<p>Different services offered by the organization</p>
</li>
</ol>
<blockquote>
<p><em>Output</em></p>
</blockquote>
<ol>
<li>
<p>In create operation: a new trust list entry MUST be created</p>
</li>
<li>
<p>In read operation: the API endpoints MUST have the flexibility to read the whole trust list and also separate entities using UUID</p>
</li>
<li>
<p>In update operation: the change requested by the user MUST be reflected in trust list</p>
</li>
<li>
<p>In delete operation: the trust list entry of the entity MUST be deleted from the list</p>
</li>
<li>
<p>Must contain auditing mechanisms for the trust list. Please refer to the trust concept document [GX.TRUST] for different mechanisms listed there.</p>
</li>
<li>
<p>Must be able to integrate with the Notarization API</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>A request update has been successfully reflected in the trust list (200)</p>
</li>
<li>
<p>A wrong context or missing data leads to an exception (400)</p>
</li>
<li>
<p>Audit entry created</p>
</li>
<li>
<p>Error, if record is in progress by the operator</p>
</li>
<li>
<p>Integrate with the Notarization API  </p>
</li>
</ol>
<h4 id="idmtrain00016-trusted-content-resolver-trust-discovery">[IDM.TRAIN.00016] Trusted Content Resolver (Trust Discovery)</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality MUST allow for the resolution of the trust list to find the issuer details in the trust list. The resolver MUST base of the DIF Universal Resolver[13] and MUST provide additional functionality to iterate recursive over DID Documents by resolving references in service endpoints during the standard resolving. The Resolver MUST integrate with the TSA via libraries. The resolving MUST be controllable by giving a list of endpoint types which are considered during the resolving by a defined range of actions. Responding content references MUST be collected and provided to the user either as list or as Callback during/after the resolving of standard documents. For instance, when a DID is resolved, the extended universal resolver collects additional DIDs from the service endpoint section (selected by types) and searches there again for other content. During this process, the defined content types are collected as reference. E.g., a list of URLs to type "gx-trusted-issuer" grouped by DID for a later processing by the libraries.</p>
</blockquote>
<h6 id="13-httpsgithubcomdecentralized-identityuniversal-resolver">[13] <a href="https://github.com/decentralized-identity/universal-resolver"><u>[https://github.com/decentralized-identity/universal-resolver]</u></a></h6>
<blockquote>
<p><em>Constraints</em></p>
<p>The following constraints MUST be fulfilled:</p>
</blockquote>
<ul>
<li>
<p>Resolve DNS PTR queries</p>
</li>
<li>
<p>Resolve DID URI queries</p>
</li>
<li>
<p>Navigate to corresponding service type on the DID Document to fetch the corresponding trust list based on user inputs</p>
</li>
<li>
<p>Handle multiple Trust Framework Pointer as array</p>
</li>
<li>
<p>Validate DNS Name against DNSSEC</p>
</li>
<li>
<p>Provision MUST be made to allow user to configure their own DNS Resolvers</p>
</li>
<li>
<p>Support different user defined trust list content types for corresponding trust list discovery</p>
</li>
</ul>
<blockquote>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>DNS Resolver</p>
</li>
<li>
<p>Universal DID Resolver[14]</p>
</li>
<li>
<p>DNSSEC validator</p>
</li>
</ul>
<h6 id="14-httpsgithubcomdecentralized-identityuniversal-resolver">[14] <a href="https://github.com/decentralized-identity/universal-resolver"><u>[https://github.com/decentralized-identity/universal-resolver]</u></a></h6>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ol>
<li>
<p>Trust Framework Pointer (e.g., example.federation1.de) + Types to be considered</p>
</li>
<li>
<p>Issuer details from the VC/VP (e.g., DID/URI)</p>
</li>
<li>
<p>ServiceType of the trust list (e.g., issuance service, verifier service)</p>
</li>
</ol>
<blockquote>
<p><em>Output</em></p>
</blockquote>
<ol>
<li>
<p>Corresponding DID mapped to Trust Framework Pointer</p>
</li>
<li>
<p>DID Document of the DID</p>
</li>
<li>
<p>Trust List VC endpoint</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>Use standardized DNS resolvers</p>
</li>
<li>
<p>Use standardized DID resolver</p>
</li>
<li>
<p>Navigate multiple trust framework pointers</p>
</li>
<li>
<p>Discover different trust list formats</p>
</li>
<li>
<p>Support different service types</p>
</li>
<li>
<p>Optimized search mechanisms (e.g., Merkle Tree)</p>
</li>
<li>
<p>MUST Allow configuration of different DNS Name Servers</p>
</li>
<li>
<p>MUST allow configuration of user defined service content type (e.g., gxfs-trusted-issuer)</p>
</li>
<li>
<p>The complete discovery process MUST be able to integrate with the TSA via libraries in GO, JAVA, Javascript, Python  </p>
</li>
</ol>
<h4 id="idmtrain00017-validation">[IDM.TRAIN.00017] Validation</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality MUST validate the output of the trust discovery functionality of the Trusted Content Resolver. The validation functionality MUST validate the association of DID with a well- known DID configuration. And MUST also be able to validate the integrity of the VC. Then it MUST also be able to validate the issuer details from the trust lists extracted from service endpoints. The validation functionality MUST integrate with the TSA via libraries.</p>
<p><em>Constraints</em></p>
<p>The following constraints MUST be fulfilled:</p>
</blockquote>
<ul>
<li>
<p>Validate the association of a DID with a well-known DID Configuration</p>
</li>
<li>
<p>Verify the proof of a VC with a public key from a DID Document</p>
</li>
<li>
<p>Display the metadata information, public keys, schema from the trust list</p>
</li>
<li>
<p>Support multiple signature proofs</p>
</li>
</ul>
<blockquote>
<p><em>Interfaces</em></p>
</blockquote>
<ol>
<li>Trust Discovery</li>
</ol>
<blockquote>
<p><em>Input</em></p>
<p>The inputs for validation are based on the output of the trust discovery functionality</p>
</blockquote>
<ol>
<li>
<p>Corresponding DID mapped to Trust Framework Pointer</p>
</li>
<li>
<p>DID Document of the DID</p>
</li>
<li>
<p>Trust List VC endpoint</p>
</li>
</ol>
<blockquote>
<p><em>Output</em></p>
</blockquote>
<ol>
<li>
<p>Validation result of VC</p>
</li>
<li>
<p>Validation result of Issuer details (present/not present)</p>
</li>
<li>
<p>If Issuer details are found, display meta data information, public keys, schema from the trust list</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>VC validation mechanism supports multiple signature proofs</p>
</li>
<li>
<p>Standardized open-source libraries for validation in GO, JAVA, Javascript, Python</p>
</li>
<li>
<p>OCI compliant containerization (Dockerized)</p>
</li>
<li>
<p>Resolve different trust strategies</p>
</li>
<li>
<p>Resolve multiple lists</p>
</li>
<li>
<p>Implement the resolving strategies</p>
</li>
<li>
<p>The complete validation process of the Trusted Content Resolver MUST be able to integrate with the TSA via libraries in GO, JAVA, Javascript, Python  </p>
</li>
</ol>
<h4 id="idmtrain00018-translate-xml">[IDM.TRAIN.00018] Translate xml</h4>
<blockquote>
<p>This functionality of the Trusted Content Resolver is responsible for detecting and translating the format of the trust list. If the format of the trust list is XML, this functionality is responsible for finding the right attributes and passing the information to the validation functionality.  </p>
</blockquote>
<h4 id="idmtrain00019-translate-json">[IDM.TRAIN.00019] Translate JSON</h4>
<blockquote>
<p>This functionality at Trusted Content Resolver is responsible for detecting and translating the format of the trust list. If the format of the trust list is JSON, this functionality is responsible for finding the right attributes and pass the information to the validation functionality.<br />
</p>
</blockquote>
<h4 id="idmtrain00020-zone-manager-handler">[IDM.TRAIN.00020] Zone Manager Handler</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality part of TSPA is responsible for configuring the TSPA with Zone Manger. It MUST allow publishing the Trust Framework and the DID in the DNS Zone file via the Zone Manager.</p>
<p><em>Constraints</em></p>
<p>The config file MUST be configured with the Domain Name of the Zone Manager and the password in order for the Zone Manager Handler to be able to communicate with the zone manager.</p>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Zone Manager</p>
</li>
<li>
<p>Trust Framework and Trust List Pointer Storage</p>
</li>
<li>
<p>Trust Framework Configuration</p>
</li>
</ul>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>The TSPA MUST be able to configure the Zone Manager using the Zone Manager Handler.</li>
</ol>
<h4 id="idmtrain00021-federation-specific-framework-and-trust-lists">[IDM.TRAIN.00021] Federation specific Framework and Trust Lists</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality is responsible for providing the trust list data model for federation specific use cases.</p>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Trust Framework Configuration</p>
</li>
<li>
<p>Trust List Management</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ul>
<li>No input</li>
</ul>
<blockquote>
<p><em>Output</em></p>
<p>The Trust List Data model MUST cover the following aspects in detail:</p>
</blockquote>
<ol>
<li>
<p>Business rules</p>
</li>
<li>
<p>Federation meta data (e.g., legal name, etc.)</p>
</li>
<li>
<p>Accommodate different identifiers (e.g., LEI - Legal Entity Identifier)</p>
</li>
<li>
<p>Accommodate assurance levels</p>
</li>
<li>
<p>Accommodate different digital identities (e.g., DID, PKI)</p>
</li>
<li>
<p>Different services offered by the federation</p>
</li>
<li>
<p>Accommodate auditable history information URI in trust list</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>Analysis with existing standards (e.g., ETSI, NIST, etc.)</p>
</li>
<li>
<p>Trust list data model in JSON and XML format with proper semantics</p>
</li>
<li>
<p>Address three use cases (i.e., Automotive, IIOT, Dataspaces )  </p>
</li>
</ol>
<h4 id="idmtrain00022-participant-specific-frameworks-and-trust-lists">[IDM.TRAIN.00022] Participant specific Frameworks and Trust Lists</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality is responsible for providing the trust list data model for participant specific use cases.</p>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Trust Framework Configuration</p>
</li>
<li>
<p>Trust List Management</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ul>
<li>No input</li>
</ul>
<blockquote>
<p><em>Output</em></p>
<p>The Trust List Data model MUST cover the following aspects in detail:</p>
</blockquote>
<ol>
<li>
<p>Business rules</p>
</li>
<li>
<p>Participant meta data (e.g., legal name, etc.)</p>
</li>
<li>
<p>Accommodate different identifiers (e.g.: LEI)</p>
</li>
<li>
<p>Accommodate assurance levels</p>
</li>
<li>
<p>Accommodate different digital identities (e.g., DID, PKI)</p>
</li>
<li>
<p>Different services trusted by the participant</p>
</li>
<li>
<p>Accommodate auditable history information URI in trust list</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>Analysis with existing standards (e.g., ETSI, NIST, etc.)</p>
</li>
<li>
<p>Trust list data model in json and xml format with proper semantics</p>
</li>
<li>
<p>Address three use cases for different participants  </p>
</li>
</ol>
<h4 id="idmtrain00023-organization-specific-frameworks-and-trust-lists">[IDM.TRAIN.00023] Organization specific Frameworks and Trust Lists</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality is responsible for providing the trust list data models for organization specific use cases.</p>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Trust Framework Configuration</p>
</li>
<li>
<p>Trust List Management</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ul>
<li>No input</li>
</ul>
<blockquote>
<p><em>Output</em></p>
<p>The Trust List Data model MUST cover the following aspects in detail.</p>
</blockquote>
<ol>
<li>
<p>Business rules</p>
</li>
<li>
<p>Organization meta data (e.g., legal name, etc.)</p>
</li>
<li>
<p>Accommodate different identifiers (e.g., LEI)</p>
</li>
<li>
<p>Accommodate assurance levels</p>
</li>
<li>
<p>Accommodate different digital identities (e.g., DID, PKI)</p>
</li>
<li>
<p>Different services offered by the organization</p>
</li>
<li>
<p>Accommodate auditable history information URI in trust list</p>
</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>Analysis with existing standards (e.g.., ETSI, NIST)</p>
</li>
<li>
<p>Trust list data model in json and xml format with proper semantics</p>
</li>
<li>
<p>Address three use cases for different organizations  </p>
</li>
</ol>
<h4 id="idmtrain00024-zone-manager">[IDM.TRAIN.00024] Zone Manager</h4>
<blockquote>
<p><em>Description</em></p>
<p>This functionality MUST allow publishing the Trust Framework and the DID in the DNS Zone file. It integrates with the TSPA Manager using the Zone Manager Handler.</p>
<p><em>Constraints</em></p>
</blockquote>
<ul>
<li>
<p>Zone Manager MUST be extended on the code base [LIGHTEST.ZM]</p>
</li>
<li>
<p>Trust Frameworks MUST be published as PTR records</p>
</li>
<li>
<p>DIDs corresponding to Trust Frameworks MUST be published as URI records</p>
</li>
<li>
<p>Zone Manager MUST provide DNSSEC configurations</p>
</li>
<li>
<p>Zone File MUST be re-signed on every new update</p>
</li>
<li>
<p>MUST allow trust framework to point to multiple other trust frameworks</p>
</li>
</ul>
<blockquote>
<p><em>Interfaces</em></p>
</blockquote>
<ul>
<li>
<p>Zone Manager Handler</p>
</li>
<li>
<p>Trust Framework and Trust List Pointers Storage (sqlite)</p>
</li>
<li>
<p>TSPA Manager</p>
</li>
<li>
<p>DNS Servers (NSD &amp; KNOT)</p>
</li>
</ul>
<blockquote>
<p><em>Input</em></p>
</blockquote>
<ol>
<li>
<p>Trust Framework</p>
</li>
<li>
<p>DID Enrollment corresponding to Trust Framework</p>
</li>
</ol>
<blockquote>
<p><em>Output</em></p>
</blockquote>
<ol>
<li>Update of Trust Framework and DID in the DNS Zone file</li>
</ol>
<blockquote>
<p><em>Acceptance Criteria</em></p>
<p>The following acceptance criteria MUST be met:</p>
</blockquote>
<ol>
<li>
<p>A request update has been successfully reflected in the sqlite storage and Zone file (200)</p>
</li>
<li>
<p>A wrong context or missing data leads to an exception (400)</p>
</li>
<li>
<p>An audit entry is created</p>
</li>
<li>
<p>An error, if record is in progress by the operator</p>
</li>
<li>
<p>MUST integrate with the TSPA Manager using the Zone Manager Handler</p>
</li>
<li>
<p>MUST be tested with NSD &amp; KNOT DNS Servers  </p>
</li>
</ol>
<h2 id="nonfunctional-requirements">Nonfunctional Requirements</h2>
<h3 id="http-requirements">HTTP Requirements</h3>
<h4 id="idmtrain00025-https">[IDM.TRAIN.00025] HTTPS</h4>
<blockquote>
<p>All HTTP Endpoints MUST be protected by TLS 1.2 (all protocol version numbers SHOULD be superseded by upcoming standards). Each endpoint of the product MUST support TLS certificates which are configurable by the administrator of the system.  </p>
</blockquote>
<h4 id="idmtrain00026-http-protocol-definitions-idmtrain00026-http-protocol-definitions-unnumbered">[IDM.TRAIN.00026] HTTP Protocol Definitions {#idm.train.00026-http-protocol-definitions .unnumbered}</h4>
<blockquote>
<p>All HTTP Endpoints MUST follow
<a href="https://docs.google.com/document/d/1HuKgAvoycVhDudUGPvlA5gEOaJywItXv/edit#bookmark%3Did.1ksv4uv">RFC7231</a> and <a href="https://docs.google.com/document/d/1HuKgAvoycVhDudUGPvlA5gEOaJywItXv/edit#bookmark%3Did.4fsjm0b">RFC5789</a> but it MAY be chosen which of the protocols are necessary to realize the functionality. For problem reports the <a href="https://docs.google.com/document/d/1HuKgAvoycVhDudUGPvlA5gEOaJywItXv/edit#bookmark%3Did.2uxtw84">RFC7807</a> MUST be used in combination with Standard HTTP Error Codes.  </p>
</blockquote>
<h3 id="logging-requirements">Logging Requirements</h3>
<h4 id="idmtrain00027-data-minimization">[IDM.TRAIN.00027] Data Minimization</h4>
<blockquote>
<p>The data minimization principle is expressed in Article 5(1)(c) of the GDPR and Article 4(1)(c) of Regulation (EU) 2018/1725, which provide that personal data must be \"adequate, relevant and limited to what is necessary in relation to the purposes for which they are processed\". The data shall be stored for a period of time in accordance with national requirements and, as a minimum, shall consist of the following elements:</p>
</blockquote>
<p>a.  node\'s identification</p>
<p>b.  message identification</p>
<p>c.  message data and time</p>
<blockquote>
<p>All logged data/information MUST be documented in the GDPR design decisions for a GDPR review.  </p>
</blockquote>
<h4 id="idmtrain00028-logging-frameworks">[IDM.TRAIN.00028] Logging Frameworks</h4>
<blockquote>
<p>The product MUST support logging frameworks e.g., graylog, fluentD or logstash to support logging and analysis by enterprise infrastructures. The supported framework MAY be chosen for the first version, but it MUST support the common open-source logging solutions with OpenTelemetry[15] support. The final solution MUST be aligned with the other subcomponents. It MUST be sketched in the operations concept how the support of multiple solutions is given in the future.</p>
</blockquote>
<h6 id="15-httpsopentelemetryio">[15] <a href="https://opentelemetry.io/"><u>[https://opentelemetry.io/]</u></a></h6>
<h3 id="performance-requirements">Performance Requirements</h3>
<h4 id="idmtrain00029-updown-scale">[IDM.TRAIN.00029] Up/Down Scale</h4>
<blockquote>
<p>All components MUST be able to scale out/down their functionality for an undefined amount of instances. This requires a parallel execution possibility which will be tested later on by performance tests.  </p>
</blockquote>
<h4 id="idmtrain00030-docker-and-kubernetes-deployment">[IDM.TRAIN.00030] Docker and Kubernetes Deployment</h4>
<blockquote>
<p>Trust Framework and Trust List Provision service MUST provide a OCI containerized (dockerized) version for example DID with a DID Document that can be published locally and also a sample trust list enveloped in a VC that can be run on a local server for testing purposes.</p>
<p>A OCI containerized version of the Trust Framework and Trust List Provision service MUST be able to be integrated with DNS Zone Manager.</p>
<p>An implementation of the DNS Zone Manager MUST be tested with core DNS Kubernetes and also the service MUST be OCI containerized and able to resolve queries from the Trusted Content Resolver.  </p>
</blockquote>
<h4 id="idmtrain00031-integration-functionality">[IDM.TRAIN.00031] Integration Functionality</h4>
<blockquote>
<p>The DNS Zone Manager MUST be able to integrate Trust Framework and Trust List Provision Services.  </p>
</blockquote>
<h4 id="idmtrain00032-resolving-functionality">[IDM.TRAIN.00032] Resolving Functionality</h4>
<blockquote>
<p>The Trusted Content Resolver MUST be able to resolve DNS Queries and MUST be able to fetch and verify trust framework and trust list provision services.  </p>
</blockquote>
<h3 id="safety-requirements">Safety Requirements</h3>
<h4 id="idmtrain00033-major-releases">[IDM.TRAIN.00033] Major Releases</h4>
<blockquote>
<p>All used software components MUST use the major releases with Long Term Support (LTS). If no LTS is available, all components MUST use the latest major releases with security hardening.  </p>
</blockquote>
<h3 id="security-requirements">Security Requirements</h3>
<h4 id="idmtrain00034-cve-patches">[IDM.TRAIN.00034] CVE Patches</h4>
<blockquote>
<p>All software components MUST have applied CVE patches, which are available for major releases.</p>
</blockquote>
<h4 id="idmtrain00035-risk-management-and-pentesting-requirements">[IDM.TRAIN.00035] Risk-Management and Pentesting Requirements</h4>
<blockquote>
<p>An adequate security risk management process is applied compliant to EU ENISA Risk Management in usage of a Tread Modelling Process like PASTA[16] or OWSAP[17]</p>
<p>All software components MUST be compliant to the requirements of the Pentesting like BSI IS- Penetrationstest[18]</p>
</blockquote>
<h6 id="16-httpsthreat-modelingcompasta-threat-modeling">[16] <a href="https://threat-modeling.com/pasta-threat-modeling/"><u>[https://threat-modeling.com/pasta-threat-modeling/]</u></a></h6>
<h6 id="17-httpsowasporgwww-communitythreat_modeling_process">[17] <a href="https://owasp.org/www-community/Threat_Modeling_Process"><u>[https://owasp.org/www-community/Threat_Modeling_Process]</u></a></h6>
<h6 id="18-httpswwwbsibunddeshareddocsdownloadsdebsisicherheitsberatungpentest_webcheckleitfaden_penetrationstestpdfblobpublicationfilev10">[18] <a href="https://www.bsi.bund.de/SharedDocs/Downloads/DE/BSI/Sicherheitsberatung/Pentest_Webcheck/Leitfaden_Penetrationstest.pdf?blob=publicationFile&amp;v=10"><u>[https://www.bsi.bund.de/SharedDocs/Downloads/DE/BSI/Sicherheitsberatung/Pentest_Webcheck/Leitfaden_Penetrationstest.pdf?blob=publicationFile&amp;v=10]</u></a></h6>
<h3 id="software-quality-attributes">Software Quality Attributes</h3>
<h4 id="idmtrain00036-software-quality-requirements">[IDM.TRAIN.00036] Software Quality Requirements</h4>
<blockquote>
<p>All software components MUST be compliant to the requirements within the quality assurance repository[19]. This includes testing on different layers (unit, component, integration), branch model that support stages, patch management, and code quality verification with adequate reporting. In addition, all requirements and quality attributes MUST demonstrated by automated behavior driven testing (BDD) methodology. </p>
</blockquote>
<h6 id="19-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesquality-assurance-issues">[19] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/quality-assurance/-/issues]</u></a></h6>
<h3 id="business-rules">Business Rules</h3>
<h4 id="idmtrain00037-software-consistency">[IDM.TRAIN.00037] Software Consistency</h4>
<blockquote>
<p>The used technologies MUST have consistency. Standard technologies e.g., databases MUST be abstracted over JDBC, authentication over OIDC etc.  </p>
</blockquote>
<h4 id="idmtrain00038-cherry-picking">[IDM.TRAIN.00038] Cherry Picking</h4>
<blockquote>
<p>All components and the entire software architecture MUST be checked for the necessity for deployment of each single feature, to allow enterprise deployment customization.  </p>
</blockquote>
<h2 id="compliance">Compliance</h2>
<h4 id="idmtrain00039-gdpr-audit-logging">[IDM.TRAIN.00039] GDPR Audit Logging</h4>
<blockquote>
<p>The seven EU GDPR principles MUST be considered: Data handling and logging MUST fulfill lawfulness, fairness and transparency; purpose limitation; data minimization; accuracy; storage limitation; integrity and confidentiality (security); and accountability.  </p>
</blockquote>
<h4 id="idmtrain00040-gdpr-data-processing">[IDM.TRAIN.00040] GDPR Data Processing</h4>
<blockquote>
<p>Is it necessary to process person-relevant data, it MUST be earmarked to a clearly defined business process, which has to be described in the GDPR design decisions. All relevant data MUST be deleted after the processing, if applicable.  </p>
</blockquote>
<h2 id="design-and-implementation">Design and Implementation</h2>
<h3 id="installation">Installation</h3>
<h4 id="idmtrain00041-helmargo-cd-deployment">[IDM.TRAIN.00041] Helm/Argo CD Deployment</h4>
<blockquote>
<p>All installations MUST be scripted/templated to ensure automated deployment into an enterprise Kubernetes cluster (K8S), SCS K8S demonstration cluster and local K8S development instance. This MUST be ensured uniform over HELM templates which MUST follow uniform across all lots (orientation on existing deployment pipelines from phase I and with alignment with the contractor). The charts MUST be integrable in a ARGO CD Pipeline defined in the gxfs-integration repository[20]. </p>
</blockquote>
<h6 id="20-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesgxfs-integration">[20] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration]</u></a></h6>
<h3 id="configuration">Configuration</h3>
<h4 id="idmtrain00042-configuration">[IDM.TRAIN.00042] Configuration</h4>
<blockquote>
<p>All components MUST support one of the major configuration formats (yaml, json, ini, environment variables) wherever configuration is required. If environment variables are overwriting an actively set configuration, a warning SHOULD be logged.  </p>
</blockquote>
<h3 id="distribution">Distribution</h3>
<h4 id="idmtrain00043-helm-repositories">[IDM.TRAIN.00043] Helm Repositories</h4>
<blockquote>
<p>All component helm charts MUST be available under a helm repository hosted in the gitlab, with different channels for distribution[21]. </p>
</blockquote>
<h6 id="21-httpsgitlabcomapiv4projects41175300packageshelmintegrationindexyaml">[21] <a href="https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml"><u>[https://gitlab.com/api/v4/projects/41175300/packages/helm/Integration/index.yaml]</u></a></h6>
<h4 id="idmtrain00044-istio-resources">[IDM.TRAIN.00044] Istio Resources</h4>
<blockquote>
<p>Additionally, the Charts MUST provide Istio Resource (e.g., Authorization Rules, Virtual Services etc.) following the integration pattern specified in the gxfs-integration repo[22].</p>
</blockquote>
<h6 id="22-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesgxfs-integration">[22] <a href="https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration]</u></a></h6>
<h3 id="service-meshing">Service Meshing</h3>
<h4 id="idmtrain00045-istio-support">[IDM.TRAIN.00045] Istio Support</h4>
<blockquote>
<p>All HELM charts MUST be provided with Istio support aligned together with the contractor. This consists of Authorization Rules, Virtual Service Definitions and other relevant Istio Definitions which are required for integration in a Istio Environment.  </p>
</blockquote>
<h3 id="standard-technology-stack">Standard Technology Stack</h3>
<h4 id="idmtrain00046-default-toolstack">[IDM.TRAIN.00046] Default Toolstack</h4>
<blockquote>
<p>Each development MUST consider the following standard technologies if nothing else is explicitly requested:</p>
</blockquote>
<table>
<thead>
<tr>
<th><strong>Area</strong></th>
<th><strong>Technology</strong></th>
</tr>
</thead>
<tbody>
<tr>
<td>Service Meshing</td>
<td>Istio</td>
</tr>
<tr>
<td>Databases</td>
<td>Redis, Mongo, Postgres</td>
</tr>
<tr>
<td>Messaging</td>
<td>CloudEvents</td>
</tr>
<tr>
<td>Continuous Integration</td>
<td>Argo CD, Gitlab</td>
</tr>
<tr>
<td>Installation Templates</td>
<td>HELM</td>
</tr>
<tr>
<td>Container</td>
<td>Docker Images (ARM64/AMD64)</td>
</tr>
<tr>
<td>Secret Storage</td>
<td>Hashicorp Vault, k8s Secret</td>
</tr>
<tr>
<td>UI Technology</td>
<td>React[23]</td>
</tr>
<tr>
<td>Ingress Controller</td>
<td>Nginx</td>
</tr>
<tr>
<td>API Testing</td>
<td>Postman (manual)</td>
</tr>
<tr>
<td>API Design</td>
<td>OpenAPI</td>
</tr>
<tr>
<td>&gt; Table 2 Standard Technology Stack</td>
<td></td>
</tr>
</tbody>
</table>
<h6 id="23-httpsreact-bootstrapgithubio">[23] <a href="https://react-bootstrap.github.io/"><u>[https://react-bootstrap.github.io/]</u></a></h6>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /> </p>
<p>The technology stack is mandatory to avoid integration impact.</p>
</blockquote>
<hr />
<h3 id="metrics">Metrics</h3>
<h4 id="idmtrain00047-opentelemetry-support">[IDM.TRAIN.00047] Opentelemetry Support</h4>
<blockquote>
<p>All helm charts/services MUST provide metrics endpoints in opentelemetry[24] format. </p>
</blockquote>
<h6 id="24-httpsopentelemetryiodocs">[24] <a href="https://opentelemetry.io/docs/"><u>[https://opentelemetry.io/docs/]</u></a></h6>
<h3 id="configurability">Configurability</h3>
<h4 id="idmtrain00048-configuration-profiles">[IDM.TRAIN.00048] Configuration Profiles</h4>
<blockquote>
<p>Environment specific parameters MUST be configurable over the helm templates by using profiles. Each component MUST be delivered minimum for profile:</p>
</blockquote>
<ul>
<li>
<p>DEV, a local environment for round trip development and testing</p>
</li>
<li>
<p>Acceptance, a restricted resource environment (with minimal system requirements) which can be deployed in cluster (remote or locally)</p>
</li>
<li>
<p>Prod, a scalable environment with fault tolerance, HA settings and security hardening</p>
</li>
</ul>
<h4 id="idmtrain00049-secret-references-in-helm-charts">[IDM.TRAIN.00049] Secret References in Helm Charts</h4>
<blockquote>
<p>The configuration secrets within Helm Charts MUST use secretRefs to support external Secret Management. Clear text secrets within the Helm Charts are not allowed.  </p>
</blockquote>
<h3 id="maintainability">Maintainability</h3>
<h4 id="idmtrain00050-microservice-architecture">[IDM.TRAIN.00050] Microservice Architecture</h4>
<blockquote>
<p>For a better scale out, maintainability and decentralization, the product architecture MUST have a microservice architecture. Each microservice MUST NOT be limited on the lines of code or number of days to implement. The service "size" SHOULD be oriented on the fine granular business capabilities. (e.g., Order, ListMenu, Payment).  </p>
</blockquote>
<h4 id="idmtrain00051-domain-driven-design">[IDM.TRAIN.00051] Domain Driven Design</h4>
<blockquote>
<p>To support the microservice architecture within the maintainability, a domain model MUST be declared before realization. The software description MUST explain which domain model was chosen, which services contain it and how it scales. This MUST be documented in the public code repository to support future enhancements for new developers.  </p>
</blockquote>
<h3 id="reusability">Reusability</h3>
<h4 id="idmtrain00052-enterprise-environments">[IDM.TRAIN.00052] Enterprise Environments</h4>
<blockquote>
<p>All components MUST be reusable in different enterprise environments by customization and whitelabeling. This means that all components MUST be able to customize and white label the components by configuration settings (e.g., UIs, text labels, endpoints etc.)  </p>
</blockquote>
<h3 id="runtime-stability">Runtime Stability</h3>
<h4 id="idmtrain00053-readiness-checkups">[IDM.TRAIN.00053] Readiness Checkups</h4>
<blockquote>
<p>All components MUST reflect - after bootstrap and during runtime - the correctness of the service functionality by reflecting it over health endpoints. The health endpoint MUST return failure (red), if any internal behavior failure or misconfiguration occurs (not just the software running state). This means for instance to check continuously during runtime:</p>
</blockquote>
<ul>
<li>
<p>An unreachable configured Services results in failed state</p>
</li>
<li>
<p>Configured Service Endpoints need to be checked for readiness during runtime, if not reachable, it results in failure state</p>
</li>
<li>
<p>Check dependent components (Database, Microservice etc.) behind it, if not reachable, it results in failed state  </p>
</li>
</ul>
<h3 id="high-availability-concepts">High Availability Concepts</h3>
<h4 id="idmtrain00054-redundant-deployment">[IDM.TRAIN.00054] Redundant Deployment</h4>
<blockquote>
<p>Each deployment MUST be configured for a minimum fault tolerance of 2 instances.  </p>
</blockquote>
<h3 id="proof-of-concept">Proof of Concept</h3>
<h4 id="idmtrain00055-architecture-changes">[IDM.TRAIN.00055] Architecture Changes</h4>
<blockquote>
<p>All Architecture Changes MUST be aligned with the contractor before implementation.  </p>
</blockquote>
<h1 id="system-features">System Features</h1>
<h2 id="trust-framework-and-trust-list-provision">Trust Framework and Trust List Provision</h2>
<h3 id="description-and-priority-trust-framework-and-trust-list-provision">Description and Priority - Trust Framework and Trust List Provision</h3>
<blockquote>
<p>The feature Trust Framework and Trust List Provision is responsible</p>
</blockquote>
<ul>
<li>
<p>for configuring and managing trust frameworks with its corresponding trust lists</p>
</li>
<li>
<p>for hosting the trust list VC</p>
</li>
<li>
<p>for anchoring the service end points to the DID Document</p>
</li>
<li>
<p>transferring the data to be anchored in the DNS using the Zone Manager Handler.</p>
</li>
</ul>
<blockquote>
<p>Please refer to the source code on [LIGHTEST.TSPA] for integrating the Trust Framework and Trust List Provision with the Zone Manager.</p>
</blockquote>
<h3 id="stimulusresponse-sequences-trust-framework-and-trust-list-provision">Stimulus/Response Sequences - Trust Framework and Trust List Provision</h3>
<p><img alt="" src="./media/image4.png" /></p>
<blockquote>
<p>Figure 2Trust Framework and Trust List: Stimulus/Response Sequences</p>
</blockquote>
<h3 id="functional-requirements-trust-framework-and-trust-list-provision">Functional Requirements - Trust Framework and Trust List Provision</h3>
<table>
<thead>
<tr>
<th>Functional Requirements</th>
<th></th>
</tr>
</thead>
<tbody>
<tr>
<td>Trust Framework Configuration</td>
<td></td>
</tr>
<tr>
<td>Trust List Management</td>
<td></td>
</tr>
<tr>
<td>Federation specific Framework and</td>
<td></td>
</tr>
<tr>
<td>Trustlists</td>
<td></td>
</tr>
<tr>
<td>Participant specific Frameworks and</td>
<td></td>
</tr>
<tr>
<td>Trustlists</td>
<td></td>
</tr>
<tr>
<td>Organization specific Frameworks and</td>
<td></td>
</tr>
<tr>
<td>Trustlists</td>
<td></td>
</tr>
<tr>
<td>Zone Manager Handler</td>
<td></td>
</tr>
</tbody>
</table>
<h2 id="trusted-content-resolver">Trusted Content Resolver</h2>
<h3 id="description-and-priority-trusted-content-resolver">Description and Priority - Trusted Content Resolver</h3>
<blockquote>
<p>The Trusted Content Resolver feature is responsible for the Trust Discovery and Trust Validation functionalities based on the input from the Verifiable Credential / Verifiable Presentation. The trust discovery process is realized through the DNS Resolver and the Universal DID Resolver. This feature MUST also be able to validate the cryptographic signatures of the VC and the trust list. It MUST also be able to differentiate different trust lists based on the data anchored in the VC. It MUST be able to validate the institutional trust of credentials by using issuer details on the trust list. The discovery traverse mechanism MUST be mathematically improved using efficient search algorithms (e.g., Merkle Trees). The service MUST be available as connection libraries in GO, JAVA, Javascript, python languages. The libraries SHOULD be user configurable for different input (e.g., service endpoint type: gxfs-issuer-list, gxfs-self- description) and output formats (e.g., json with defined parameters (service name, digital id, etc.). The Trusted Content Resolver MUST be able to integrate with TSA to validate the trust via libraries mentioned in the above programming languages.The service should also be dockerized and easily integrable with existing systems to validate the trust.</p>
</blockquote>
<h3 id="stimulusresponse-sequences-trusted-content-resolver">Stimulus/Response Sequences - Trusted Content Resolver</h3>
<p><img alt="" src="./media/image5.png" /></p>
<blockquote>
<p>Figure 3 Trusted Content Resolver: Stimulus/Response Sequences</p>
</blockquote>
<h3 id="functional-requirements-trusted-content-resolver">Functional Requirements - Trusted Content Resolver</h3>
<table>
<thead>
<tr>
<th>Functional Requirements</th>
</tr>
</thead>
<tbody>
<tr>
<td>Trust Discovery</td>
</tr>
<tr>
<td>Validation</td>
</tr>
<tr>
<td>Translate XML</td>
</tr>
<tr>
<td>Translate JSON</td>
</tr>
</tbody>
</table>
<h2 id="dns-zone-management">DNS Zone Management</h2>
<h3 id="description-and-priority-dns-zone-management">Description and Priority - DNS Zone Management</h3>
<blockquote>
<p>The DNS Zone Management feature is responsible for managing the DNS zone file and used for anchoring the trust framework DID information into the zone file. This feature is also responsible for resigning the zone file based on DNSSEC for every new update in the zone file. The implementation approach MUST be based on <a href="https://github.com/H2020LIGHTest/ZoneManager">https://github.com/H2020LIGHTest/ZoneManager</a> with the latest python version. The DNS server used for the backend MUST be NSD and KnotDNS. The service MUST be dockerized.</p>
</blockquote>
<h3 id="stimulusresponse-sequences-dns-zone-management">Stimulus/Response Sequences - DNS Zone Management</h3>
<p><img alt="" src="./media/image6.png" /></p>
<blockquote>
<p>Figure 4 DNS Zone Management: Stimulus/Response Sequences*</p>
</blockquote>
<h3 id="functional-requirements-dns-zone-management">Functional Requirements - DNS Zone Management</h3>
<table>
<thead>
<tr>
<th>Functional Requirement</th>
</tr>
</thead>
<tbody>
<tr>
<td>Zone Manager</td>
</tr>
</tbody>
</table>
<h1 id="verification">Verification</h1>
<h2 id="core-verification-requirements">Core Verification Requirements</h2>
<blockquote>
<p>All listed verification items/criterias MUST be fulfilled by a demonstration of the implementation within the provided Kubernetes environment.</p>
</blockquote>
<h4 id="idmtrain00056-kubernetes-deployment">[IDM.TRAIN.00056] Kubernetes Deployment</h4>
<blockquote>
<p>If the verification is related to software components, it MUST be deployed in a k8s test cluster and the components must be deployable in a Kubernetes cluster with automated package manager deployment (e.g., Helm).</p>
</blockquote>
<hr />
<blockquote>
<p><img alt="" src="../media/image2.png" /></p>
<p>Docker Compose and other local systems can be used for local development and testing, but it's NOT allowed for a final acceptance demonstration. </p>
</blockquote>
<hr />
<h2 id="support-for-kubernetes">Support for Kubernetes</h2>
<h4 id="idmtrain00057-eventing">[IDM.TRAIN.00057] Eventing</h4>
<blockquote>
<p>All eventings MUST be demonstrated based on cloud events specifications together with the kNative[25] broker in a Kubernetes environment.  </p>
</blockquote>
<h6 id="25-httpsknativedevdocseventing">[25] <a href="https://knative.dev/docs/eventing/"><u>[https://knative.dev/docs/eventing/]</u></a></h6>
<h4 id="idmtrain00058-config-map-support">[IDM.TRAIN.00058] Config Map Support</h4>
<blockquote>
<p>Each service MUST be demonstrated up and running in Kubernetes, configured by config maps.</p>
</blockquote>
<h4 id="idmtrain00059-helm-installation">[IDM.TRAIN.00059] Helm Installation</h4>
<blockquote>
<p>The service installation MUST be demonstrated during HELM install.  </p>
</blockquote>
<h4 id="idmtrain00060-argocd-integration">[IDM.TRAIN.00060] ArgoCD Integration</h4>
<blockquote>
<p>The helm chart MUST be able to install inside of argoCD. This includes
the usage of the postgres hooks[26] and the
provisioning of usable values.yaml(s) for all developed services.  </p>
</blockquote>
<h6 id="26-httpsgitlabcomgaia-xdata-infrastructure-federation-servicesgxfs-integration-treemainhelmchartspostgresql-hook">[26] <a href="hhttps://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook"><u>[https://gitlab.com/gaia-x/data-infrastructure-federation-services/gxfs-integration/-/tree/main/helm/charts/postgresql-hook]</u></a></h6>
<h4 id="idmtrain00061-scs-environment">[IDM.TRAIN.00061] SCS Environment</h4>
<blockquote>
<p>All HELM installations MUST run on SCS (Sovereign Cloud Stack). The [final acceptance] demonstration cannot be realized on azure, google cloud etc.  </p>
</blockquote>
<h2 id="functionality-acceptance-criteria">Functionality Acceptance Criteria</h2>
<h4 id="idmtrain00062-zone-managertspa-configuration">[IDM.TRAIN.00062] Zone Manager/TSPA Configuration</h4>
<blockquote>
<p>A domain was registered, and a DNSSec Server is linked to it. The product Zone Manager was installed on a machine, and it MUST be possible to link the Zone Manager with the DNSSec Server. The Zone Manager Handler MUST be configured to allow access to the zone manager (internal API). After this, using TSPA Trust Frameworks and DIDs can be published over the Zone Manager Handler into the zone file. After the rollout, using the endpoints of the TSPA with Dig commands and queries, the Trust Framework and DID (PTR and URI RR) of the Zone File are resolvable.  </p>
</blockquote>
<h4 id="idmtrain00063-trust-zone-demonstration">[IDM.TRAIN.00063] Trust Zone Demonstration</h4>
<blockquote>
<p>Trusted Content publishing and resolution MUST be demonstrated over a public domain with DNSsec functionality. Various entries MUST be added to the zone and be resolved by the Trusted Content Resolver.  </p>
</blockquote>
<h4 id="idmtrain00064-trust-framework-cross-linking-demonstration">[IDM.TRAIN.00064] Trust Framework cross-linking Demonstration</h4>
<blockquote>
<p>Cross-linking of Trust Frameworks MUST be demonstrated over two public domains with DNSsec functionality. A cross-link from one trust framework on domain 1 (using the PTR Record) MUST reference another Trust Framework on domain 2. Various entries MUST be added to the Trust Frameworks on domain 1 and domain 2 and be correctly resolved by the Trusted Content Resolver.  </p>
</blockquote>
<h4 id="idmtrain00065-trust-framework-and-did-enrollment">[IDM.TRAIN.00065] Trust Framework and DID Enrollment</h4>
<blockquote>
<p>Trust Frameworks and their corresponding DIDs MUST be enrolled using API endpoints offered by the TSPA. The enrolled details MUST be reflected in the database and the DNS Zone file of the Name server.  </p>
</blockquote>
<h4 id="idmtrain00066-trusted-list-management-using-api-endpoints">[IDM.TRAIN.00066] Trusted List Management using API endpoints</h4>
<blockquote>
<p>The Trust List content MUST be managed using API endpoints. Separate API endpoints MUST be available for performing CRUD Operations. </p>
</blockquote>
<h4 id="idmtrain00067-trusted-content-resolver-resolves-trust-zone-pointers">[IDM.TRAIN.00067] Trusted Content Resolver resolves Trust Zone Pointers</h4>
<blockquote>
<p>The trusted content resolver is called by a Trust Framework Pointer (URL/DNS Name). The resolver recognizes that a DNS query must be made and it's starting to resolve the records about other Trust Framework Pointers (if applicable). After resolving the entire Zone, the DIDs of the RR/URI Records can be resolved as usual. Output is a List of Pointers which the resolver returns. </p>
</blockquote>
<h4 id="idmtrain00068-trusted-content-resolver-resolves-trusted-content">[IDM.TRAIN.00068] Trusted Content Resolver resolves Trusted Content</h4>
<blockquote>
<p>The trusted content resolver is called by a DID, and a list of requested content types. The resolver resolves the DID, iterates through the service endpoint references, and returns a list of trust lists (no DID documents), regarding the given DID. The DID documents for the resolved references can be found in a second list.  </p>
</blockquote>
<h4 id="idmtrain00069-trusted-content-resolver-validates-institutional-trust-of-a-verifiable-credential">[IDM.TRAIN.00069] Trusted Content Resolver validates institutional trust of a Verifiable Credential</h4>
<blockquote>
<p>The issuer details of a credential MUST be validated with the resources found from the Trust List. This MUST be demonstrated with Trust Frameworks that are cross-linked to other Trust Frameworks (hosted on different domains) as well as Trust Frameworks that do not include a cross-linking. This MUST be available as integratable libraries for programming languages GO, Javascript, python and Java.  </p>
<p><strong>Software Requirements Specification for IDM.TRAIN 30</strong></p>
</blockquote>
<h1 id="annex-a-train-overview">Annex A: TRAIN Overview</h1>
<p><img alt="" src="../media/image3.png" /></p>
<blockquote>
<p><strong>Software Requirements Specification for IDM.TRAIN 31</strong></p>
</blockquote>
<h1 id="annex-b-overview-gxfs-work-packages">Annex B: Overview GXFS Work Packages</h1>
<blockquote>
<p>The project "Gaia-X Federation Services" (GXFS) is an initiative funded by the German Federal Ministry of Economic Affairs and Energy (BMWi) to develop the first set of Gaia-X Federation Services, which form the technical basis for the operational implementation of Gaia-X.</p>
<p>The project is structured in five Working Groups, focusing on different functional areas as follows: Work Package 1 (WP1): Identity &amp; Trust</p>
<p>Identity &amp;Trust covers authentication and authorization, credential management, decentral Identity management as well as the verification of analogue credentials.</p>
<p>Work Package 2 (WP2): Federated Catalogue</p>
<p>The Federated Catalogue constitutes the central repository for Gaia-X Self-Descriptions to enable the discovery and selection of Providers and their Service Offerings. The Self-Description as expression of properties and Claims of Participants and Assets represents a key element for transparency and trust in Gaia-X.</p>
<p>Work Package 3 (WP3): Sovereign Data Exchange</p>
<p>Data Sovereignty Services enable the sovereign data exchange of Participants by providing a Data Agreement Service and a Data Logging Service to enable the enforcement of Policies. Further, usage constraints for data exchange can be expressed by Provider Policies as part of the Self-Description</p>
<p>Work Package 4 (WP4): Compliance</p>
<p>Compliance includes mechanisms to ensure a Participant's adherence to the Policy Rules in areas such as security, privacy transparency and interoperability during onboarding and service delivery.</p>
<p>Work Package 5 (WP5): Portal &amp; Integration</p>
<p>Gaia-X Portals and API will support onboarding and Accreditation of Participants, demonstrate service discovery, orchestration, and provisioning of sample services.</p>
</blockquote>
<p><img alt="" src="../media/image7.png" /></p>
<blockquote>
<p>Further general information on the Federation Services can be found in [TAD].</p>
</blockquote>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../../notare/notare/" class="btn btn-neutral float-left" title="Notarization API Extension"><span class="icon icon-circle-arrow-left"></span> Previous</a>
        <a href="../../ocme1/ocme1/" class="btn btn-neutral float-right" title="Organization Credential Manager Extension">Next <span class="icon icon-circle-arrow-right"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../../notare/notare/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
      <span><a href="../../ocme1/ocme1/" style="color: #fcfcfc">Next &raquo;</a></span>
    
  </span>
</div>
    <script src="../../js/jquery-3.6.0.min.js"></script>
    <script>var base_url = "../..";</script>
    <script src="../../js/theme_extra.js"></script>
    <script src="../../js/theme.js"></script>
      <script src="../../search/main.js"></script>
    <script>
        jQuery(function () {
            SphinxRtdTheme.Navigation.enable(true);
        });
    </script>

</body>
</html>
